<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

include_once("definitions.php");

// set the timelimit
@set_time_limit($CONF['timelimit']);
ignore_user_abort(TRUE);

@session_start();

// used variables
if (!isset($argv)) $argv=FALSE;
if (!isset($_GET['incl'])) $_GET['incl']=FALSE;
if (!isset($_POST['db'])) $_POST['db']=FALSE;

// is shell mode or web-based mode or export-script mode used or is user not logged in?
if ($argv[1]) {
    $mode="shell";
    $_POST['db']=$argv[1];
    if ($argv[2]) $_POST['tables']="on"; else $_POST['tables']="off";
    if ($argv[3]) $_POST['data']="on"; else $_POST['data']="off";
    if ($argv[4]) $_POST['drop']="on"; else $_POST['drop']="off";
    if ($argv[5]) $_POST['zip']="on"; else $_POST['zip']="off";
} elseif (!$_SESSION['LOGGED_IN'] && !$_GET['incl']) {
    $mode="web";
    include("login.php");
} elseif ($_GET['incl']) {
    $mode="incl";
} else {
    $mode="web";
}

// print html if web mode
if ($mode=="web") {
    printHeader(ereg_replace(".*/","",$_SERVER['SCRIPT_NAME']),$CONF['lang'],$CONF['no_login']);

    // if first use or no db-connection possible
    if (!@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) echo "<div class=\"red_left\">".I_SQL_ERROR."</div><br>";
}

// if pressed 'backup' backup the db
if ($_POST['db']) {

    // get start time to calculate duration
    $starttime=time();
    
    get_backup_files($CONF['del_time']);

    // in shell mode the dbs must be seperated with commas
    if ($mode=="shell") $db_list=explode(",",$_POST['db']); else $db_list=$_POST['db'];

    // is a database selected?
    if (count($db_list)) {
        foreach($db_list as $export_db) {

            // generate db dump
            $backupfile=dump($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'],$export_db,($_POST['tables']=="on"),($_POST['data']=="on"),($_POST['drop']=="on"),($_POST['zip']=="on"));

            // is there no db connection or a not existinig db?
            if ($backupfile) {

                // change mod to 0777
                chmod("./".EXPORT_DIR.$backupfile,0777);

                // write comment
                if ($_POST['comments']) comment("set",$backupfile,$_POST['comments']);

                // remind filenames if backup by ftp or email is selected
                if (($CONF['email_use'] && function_exists('mail')) || ($CONF['ftp_use'] && function_exists('ftp_connect'))) $store_files[]=$backupfile;

                if ($mode=="web") echo "<div class=\"green\">".EX_SAVED." ".$backupfile."</div>\n"; elseif ($mode=="shell") echo EX_SAVED." ".$backupfile."\n";
            } else {
                if ($mode=="web") echo "<div class=\"red\">".EX_NOT_SAVED." ".$export_db."</div>\n"; elseif ($mode=="shell") echo EX_NOT_SAVED." ".$export_db."\n";
            }
        }
    } else {
        echo "<div class=\"red\">".EX_NO_DB."</div><br>\n";
    }

    // start backup using ftp or email
    $backup_info=array("comments"=>$_POST['comments'],"tables"=>($_POST['tables']=="on"),"data"=>($_POST['data']=="on"),"drop"=>($_POST['drop']=="on"),"gzip"=>(function_exists('gzopen') && $_POST['zip']=="on"));
    if ($CONF['email_use'] && $store_files) $out=email_store($store_files,$CONF['email'],$CONF['sitename'],$backup_info)."<br>\n";
    if ($CONF['ftp_use'] && $store_files) $out.=ftp_store($store_files,$CONF['ftp_server'],$CONF['ftp_user'],$CONF['ftp_passwd'],$CONF['ftp_path'],$CONF['ftp_pasv'],$CONF['ftp_port']);
    if ($mode=="web") {
        echo "<div class=\"green\">".$out."</div>\n";
        echo "<div class=\"bold\">".F_DURATION.": ".$duration=time()-$starttime." ".F_SECONDS."</div>\n";
    } elseif ($mode=="shell") {
        echo $out;
        echo F_DURATION.": ".$duration=time()-$starttime." ".F_SECONDS;
    }


// show the form for selecting a db to backup
} elseif (!$_POST['db'] && $mode=="web") {
    echo "<form action=\"backup.php\" method=\"post\" name=\"backup\">\n<div>\n";
    printExportForm($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd']);
    echo "\n<br><br><input type=\"submit\" value=\"".EX_EXPORT."\" class=\"button\">\n";
    echo "</div>\n</form>\n";
}

// print html if web mode
if ($mode=="web") printFooter();
?>
