<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

include("login.php");
include_once("definitions.php");

printHeader(ereg_replace(".*/","",$_SERVER['SCRIPT_NAME']),$CONF['lang'],$CONF['no_login']);

// used variables
if (!isset($_GET['import'])) $_GET['import']=FALSE;
if (!isset($_GET['imp_ALL'])) $_GET['imp_ALL']=FALSE;
if (!isset($_GET['del'])) $_GET['del']=FALSE;
if (!isset($_GET['del_ALL'])) $_GET['del_ALL']=FALSE;
if (!isset($_GET['empty_ALL'])) $_GET['empty_ALL']=FALSE;
if (!isset($_GET['del_all'])) $_GET['del_all']=FALSE;
if (!isset($_GET['empty_all'])) $_GET['empty_all']=FALSE;

// if first use or no db-connection possible
if (!$con=@mysql_connect($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd'])) echo "<div class=\"red\">".I_SQL_ERROR."</div>";

// if importing sql
if ($_GET['import'] || $_GET['imp_ALL']) {

    // get start time to calculate duration
    $starttime=time();

    if ($_GET['import']) {
        $import_files[]=$_GET['import'];
    } else {
        $all_files=get_backup_files($CONF['del_time']);
        foreach($all_files as $file) {
            $db=file_info("db","./".EXPORT_DIR.$file);
            $time=file_info("time","./".EXPORT_DIR.$file);
            if ($time>$last_files[$db][1]) {
                $last_files[$db][0]=$file;
                $last_files[$db][1]=$time;
            }
        }
        foreach($last_files as $last_file) $import_files[]=$last_file[0];
    }

    foreach($import_files as $import_file) {

        // set php timelimit
        @set_time_limit($CONF['timelimit']);
        ignore_user_abort(TRUE);

        $db=@mysql_select_db(file_info("db","./".EXPORT_DIR.$import_file));
        $data_queries=array();
        $drop_queries=array();
        $table_queries=array();

        // uncrompress gziped backup files
        if (file_info("gzip","./".EXPORT_DIR.$import_file)) {
            $lines=ungzip("lines","./".EXPORT_DIR.$import_file);
        } else {
            $lines=file("".EXPORT_DIR.$import_file);
        }

        // divide insert and create sql queries
        // $table is set to TRUE if the next line belongs to a create sql query
        $table=FALSE;
        foreach($lines as $line){
            $line=trim($line);
            
            // the last line doesn't belong to a create sql query
            if (!$table) {
            
                // this line does not, too
                if (strtolower(substr($line,0,6))=="insert") {
                    $data_queries[]=substr($line,0,strlen($line)-1);

                // this line does not, too
                } elseif (strtolower(substr($line,0,20))=="drop table if exists") {
                    $drop_queries[]=substr($line,0,strlen($line)-1);

                // this line does!
                } elseif (strtolower(substr($line,0,6))=="create") {
                    $table=TRUE;
                    $table_queries[]=$line."\n";
                }

            // this line belongs to a create sql query
            } else {

                // create sql query ending in this line
                if (strtolower(substr($line,0,1))==")") {
                    $table=FALSE;
                    $table_queries[count($table_queries)-1] .= $line."\n";
                } else {
                    $table_queries[count($table_queries)-1] .= $line."\n";
                }
            }
        }

        $sql_error=FALSE;

        // execute drop tables if exists queries
        if (is_array($drop_queries)) {
            foreach($drop_queries as $drop_query) {
                if (!@mysql_query($drop_query)) {
                    $sql_error=TRUE;
                    if ($CONF['import_error']) echo nl2br($drop_query)."\n<div class=\"bold_left\">".mysql_error()."</div><br>\n";
                }
            }
        }

        // execute create tables queries
        if (is_array($table_queries)) {
            foreach($table_queries as $table_query) {
                if (!@mysql_query($table_query)) {
                    $sql_error=TRUE;
                    if ($CONF['import_error']) echo nl2br($table_query)."\n<div class=\"bold_left\">".mysql_error()."</div><br>\n";
                }
            }
        }

        // execute insert data queries
        if (is_array($data_queries)) {
            foreach($data_queries as $data_query) {
                if (!@mysql_query($data_query)){
                    if ($CONF['import_error']) echo $data_query."\n<div class=\"bold_left\">".mysql_error()."</div><br>\n";
                    $sql_error=TRUE;
                }
            }
        }

        // show number successful executed querys or if an error did occur
        if ($sql_error==1) echo "<div class=\"red\">".IM_ERROR.".</div>\n";
            else echo "<div class=\"green\">".IM_SUCCESS." ".count($table_queries)." ".IM_TABLES." ".count($data_queries)." ".IM_ROWS."</div>\n";
    }
    echo "<div class=\"bold\">".F_DURATION.": ".$duration=time()-$starttime." ".F_SECONDS."</div>\n";
}

// remove old backup files and get list of backup files
$all_files=get_backup_files($CONF['del_time']);

// delete ALL backup files if the link was clicked
if ($_GET['del_ALL']) {
    if (is_array($all_files))
    foreach($all_files as $filename) {
        @unlink("./".EXPORT_DIR.$filename);
        comment("delete",$filename);
    }
    echo "<div class=\"green\">".B_DELETED_ALL.".</div>\n";
}

// empty ALL db if the link was clicked
if ($_GET['empty_ALL']) {
    $all_db=getDB_List($CONF['sql_host'],$CONF['sql_user'],$CONF['sql_passwd']);
    foreach($all_db as $dbname) {
        $db=mysql_select_db($dbname,$con);
        $res=mysql_list_tables($dbname,$con);
        for ($i=0;$i<mysql_num_rows($res);$i++) {
            $row=mysql_fetch_row($res);
            $tablename=$row[0];
            mysql_query("drop table `".$tablename."`",$con);
        }
    }

    $error=mysql_error();
    if ($error) echo $error; else echo "<div class=\"green\">".B_EMPTIED_ALL.".</div>\n";
}

// empty db if the link was clicked
if ($_GET['empty_all']) {
    $db=mysql_select_db($_GET['empty_all']);
    $res=mysql_list_tables($_GET['empty_all']);
    for ($i=0;$i<mysql_num_rows($res);$i++) {
        $row=mysql_fetch_row($res);
        $tablename=$row[0];
        mysql_query("drop table `".$tablename."`");
    }
    $error=mysql_error();
    if ($error) echo $error; else echo "<div class=\"green\">".B_EMPTIED.".</div>\n";
}

// delete all backup files of selected db if the link was clicked
if ($_GET['del_all']) {
    if (is_array($all_files))
    foreach($all_files as $filename) {
        if ($_GET['del_all']==file_info("db","./".EXPORT_DIR.$filename)) {
            @unlink("./".EXPORT_DIR.$filename);
            comment("delete",$filename);
        }
    }
    echo "<div class=\"green\">".B_DELETED_ALL.".</div>\n";
}

// delete selected backup file if the link was clicked
if ($_GET['del']) {
    @unlink("./".EXPORT_DIR.$_GET['del']);
    echo "<div class=\"green\">".B_DELETED.".</div>\n";
    comment("delete",$_GET['del']);
}

// get new list of backup files
$all_files=get_backup_files($CONF['del_time']);

echo "<table border=\"0\" cellspacing=\"2\" cellpadding=\"0\" width=\"100%\">\n";

// list all backup files
if (is_array($all_files)) {
    natsort($all_files);
    $last_backup=0;
    $size_sum=0;

    // print html table
    foreach($all_files as $filename) {
        $file="./".EXPORT_DIR.$filename;
        
        // generate one row for the db name
        if(!isset($printed_title[$db=file_info("db",$file)])) {
            $printed_title[$db]=TRUE;
            echo "<tr><th colspan=\"7\">".$db." <span class=\"standard\">".confirm(B_CONF_EMPTY_DB,"import.php?empty_all=".$db,"[".B_EMPTY_DB."]",$CONF['confirm']);
            echo "&nbsp;".confirm(B_CONF_DEL_ALL,"import.php?del_all=".$db,"[".B_DELETE_ALL."]",$CONF['confirm'])."</span></th></tr>\n";
        }

        echo "<tr>\n<td class=\"list\">\n".$filename."</td>\n";
        echo "<td class=\"list\">".strftime($CONF['date'],$time=file_info("time",$file))."</td>\n";
        if($time>$last_backup) $last_backup=$time;
        $size_sum+=$size=file_info("size",$file);
        $size=size_type($size);
        echo "<td class=\"list\">".$size['value']." ".$size['type']."</td>\n";
        echo "<td class=\"list\">".pop_up("file_info.php?file=".$filename,B_INFO,"info")."</td>\n";
        echo "<td class=\"list\">".pop_up("get_file.php?view=".$file,B_VIEW,"view")."</td>\n";
        if ($con) echo "<td class=\"list\">".confirm(B_CONF_IMP,"import.php?import=".$filename,B_IMPORT,$CONF['confirm'])."</td>\n";
            else echo "<td class=\"list\">".B_IMPORT."</td>\n";
        echo "<td class=\"list\">".confirm(B_CONF_DEL,"import.php?del=".$filename,B_DELETE,$CONF['confirm'])."</td>\n</tr>\n";
    }
    
    // print delete ALL backups and empty ALL dbs links if backup files are available
    $size_sum=size_type($size_sum);
    echo "<tr><td colspan=\"7\"><br><div class=\"bold\">".B_SIZE_SUM.": ".$size_sum['value']." ".$size_sum['type']." - ".B_LAST_BACKUP.": ".strftime($CONF['date'],$last_backup)."</div></td></tr>\n";
    echo "<tr><td colspan=\"7\"><div class=\"bold\">".confirm(B_CONF_EMPT_ALL,"import.php?empty_ALL=TRUE","[".B_EMPTY_ALL."]",$CONF['confirm']);
    echo "&nbsp;".confirm(B_CONF_IMP_ALL,"import.php?imp_ALL=TRUE","[".B_IMPORT_ALL."]",$CONF['confirm'])."\n";
    echo "&nbsp;".confirm(B_CONF_DEL_ALL_2,"import.php?del_ALL=TRUE","[".B_DELETE_ALL_2."]",$CONF['confirm'])."<br>&nbsp;</div></td>\n</tr>\n";
} else {

    // if there are no backup files
    echo "<tr>\n<td><div class=\"bold\">".B_NO_FILES.".</div>\n</td>\n</tr>\n";
}

echo"</table>\n";
printFooter();
?>
