<?php
/*
 +--------------------------------------------------------------------------+
 | phpMyBackupPro                                                           |
 +--------------------------------------------------------------------------+
 | Copyright (c) 2004 by Dirk Randhahn                                      |
 | http://sourceforge.net/projects/phpmybackup/                             |
 | Version information can be found in definitions.php.                     |
 |                                                                          |
 | This program is free software; you can redistribute it and/or            |
 | modify it under the terms of the GNU General Public License              |
 | as published by the Free Software Foundation; either version 2           |
 | of the License, or (at your option) any later version.                   |
 |                                                                          |
 | This program is distributed in the hope that it will be useful,          |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of           |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            |
 | GNU General Public License for more details.                             |
 |                                                                          |
 | You should have received a copy of the GNU General Public License        |
 | along with this program; if not, write to the Free Software              |
 | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,USA.|
 +--------------------------------------------------------------------------+
*/

chdir("..");

include_once("definitions.php");
include_once(MAIN_INC);

echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\"
   \"http://www.w3.org/TR/html4/loose.dtd\">
<html>
<head>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">
<link rel=\"stylesheet\" href=\"./../".STYLE_CSS."\" type=\"text/css\">
<title>phpMyBackupPro - ".F_HELP."</title>
</head>
<table border=\"0\" cellspacing=\"2\" cellpadding=\"0\" width=\"100%\">\n
<tr><th colspan=\"2\" class=\"active\"><span class=\"pmbp1\">php</span><span class=\"pmbp2\">MyBackup</span><span class=\"pmbp3\">Pro</span><span class=\"pmbp4\"> ".VERSION."</span></th></tr>
";

// choose help text
switch(preg_replace("'^.*/'","",$_GET['script'])) {
    case 'index.php': $filename=F_START;
    $html="Click help on each of the different pages to get specific help for its content.<br>
    More information you can find here: <a href=\"http://sourceforge.net/projects/phpmybackup/\" target=\"_blank\">http://sourceforge.net/projects/phpmybackup/</a><br>
    Please report bugs and spelling errors there.";
    break;
    case 'config.php': $filename=F_CONFIG;
    $html="Please insert all data concerning your database server.<br>
    For big databases you can edit the '".C_TIMELIMIT."' if you have problems with building backups or importing backups.<br>
    Additionally you can select if the backup files should be exported by FTP or email by checking the '".C_FTP_USE."' or '".C_EMAIL_USE."' checkbox.<br>
    Then you need to enter ".C_FTP_SERVER.", ".C_FTP_USER." and ".C_FTP_PASSWD." or your ".C_EMAIL.". The
    default ".C_FTP_PATH." is ./ and the default ".C_FTP_PORT." is 21.<br>
    The local backup files will automatically be deleted after the number of days you enter in '".C_DEL_TIME."'. Set it to 0 days to disable this function.
    Its also possible to use decimal numbers like 0.5 (=12 h) days.<br>
    The checkbox '".C_NO_LOGIN."' can be uses to disable the login function of phpMyBackupPro. This gives access to your data to everybody who has access to phpMyBackupPro!!! Its only recommended on local systems!<br>
    '".C_CONFIRM."' is for the links on the '".F_IMPORT."' page. Select which have to be confirmed after clicking them.<br>
    Use '".C_DATE."' to select your favorite date style. In dependency of your system some of them can exist twice.<br>
    Use '".C_LANG."' to change the panguage of phpMyBackupPro. Your can download several language packages on the phpMyBackupPro project site.<br><br>
    The passwords typed here will be saved as plain text in global_conf.php!";
    break;
    case 'import.php': $filename=F_IMPORT;
    $html="Here you can see all currently stored local backup files.<br>
    You can get more information by clicking 'info'.<br>
    By clicking 'view', you can watch the backup file<br>
    Click 'import' to re-import the file in the db. Before this you can empty the db by clicking 'empty database'<br>
    To delete a backup file click 'delete'. You can delete all files belonging to one database by clicking 'delete all backups'.<br><br>
    Click 'empty ALL databases' to empty all available databases, click 'import ALL backups' to import the last backup of each database,
    click 'delete ALL backups' to delete all available backup files.";
    break;
    case 'backup.php': $filename=F_BACKUP;
    $html="Here you can select wich databases you want to backup.<br>
    A comment will be saved to each backup file.<br>
    You can choose if just the table structure, the data or both will be stored.<br>
    Add a 'drop table if exists ...' row to each table structure by clicking 'add drop table'<br>
    By clicking 'gzip file' the file will be stored in the gzip format. This will only work if the php gzib-functions are available on your system.";
    break;
    case 'export_script.php': $filename=F_SCHEDULE;
    $html="To automate the backup, you can generate some code to include in any existing php script.<br>
    When this script is loaded, the backup automatically starts.<br><br>
    You can decide in which periods the backup will run.<br><br>
    Next choose where the script will be located later. The directory phpMyBackupPro.".VERSION." must not be moved any more. (If you have knowledge of coding php you can change the path later.)<br><br>
    The backup will only run, if anybody opens this page! One solution is to use a frame set with an invisible frame.<br><br>
    All configurations you made will work in this script!<br> You can find more information about the backup options in the 'backup' help.";
    break;
    case 'db_info.php': $filename=F_DB_INFO;
    $html="Here you can see a small summary of your databases.<br><br>
    In the column 'number of rows' you can find the sum of the number of rows from all tables.<br>
    If a database contains tables, you can click 'tables info' to get the names, number of cols, number of rows and size of all tables of the respective database.<br>
    The sizes may differ from the sizes of backup files because of additional data needed in the backup files.";
    break;
    case 'sql_query.php': $filename=F_SQL_QUERY;
    $html="This page is to send simple sql queries to the database.<br><br>
    You can select a database on which you want to run the queries.<br>
    You can insert one or more sql queries in the textbox.<br>
    Queries like 'select ...' will return a result table.<br>
    Some queries like 'delete ...' will only tell you '".SQ_SUCCESS."'<br><br>
    If you upload a file to be executed you will receive an error message for each error that has happened! (and this could be a lot!)<br>
    The last error message contains a list of all queries, which generated errors. An 'F' before a number of the query means this query was in the file.<br><br>
    These functions are not mature yet! There is no guarantee that all correct queries can be processed succesfully!";
    break;
    default: $html="Sorry, no help available for this site.";
}

echo "<tr>\n<td>\n";
if ($filename) echo "<br><div class=\"bold_left\">Help for ".$filename.":</div><br>\n";
echo $html;
echo "</td>\n</tr>\n</table>\n</body>\n</html>";
?>
